### Method

# Clutter Event get_device

#### Declaration [src]

    ClutterInputDevice*
    clutter_event_get_device (
      const ClutterEvent* event
    )

#### Description [src]

Retrieves the `ClutterInputDevice` for the event. If you want the physical device the event originated from, use `clutter_event_get_source_device()`.

The `ClutterInputDevice` structure is completely opaque and should be cast to the platform-specific implementation.

#### Return value

Type: `ClutterInputDevice`

The `ClutterInputDevice` or `NULL`. The returned device is owned by the `ClutterEvent` and it should not be unreferenced.

The returned data is owned by the instance.